<?php
namespace Geral\Entities;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

/**
 * Class Paramgeral
 * @package Geral\Entities
 * @method static \Geral\Entities\Paramgeral findOneByNrorg($nrorg)
 */
class Paramgeral extends Base\Paramgeral
{
	/**
     *
     */
    const IDEMPDESTREPAUT_SIM = "S";
    /**
     *
     */
    const IDEMPDESTREPAUT_NAO = "N";


    public static function atualizaParamgeral(
        $nrorg, $cdpargeral, $cdindicemf, $cdtpindice, $idpervalor, $cdindicemf2,
        $cdtpindice2, $idpervalor2, $qtbloqnestop, $qtlibnestor, $vrpecurvaa,
        $vrpecurvab, $vrpecurvac
    )
    {
        try {
            $paramgeral = self::getObjectByWhere(
                'NRORG = ? AND CDPARGERAL = ?', array($nrorg, $cdpargeral)
            );

            if ($paramgeral instanceof Paramgeral) {
                $dataAtual = DateUtil::getDataAtual();
                $operador  = Ambiente::getCdoperador();

                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $paramgeral->setCdindicemf($cdindicemf);
                $paramgeral->setCdtpindice($cdtpindice);
                $paramgeral->setIdpervalor($idpervalor);
                $paramgeral->setCdindicemf2($cdindicemf2);
                $paramgeral->setCdtpindice2($cdtpindice2);
                $paramgeral->setIdpervalor2($idpervalor2);
                $paramgeral->setQtbloqnestop($qtbloqnestop);
                $paramgeral->setQtlibenestor($qtlibnestor);
                $paramgeral->setVrpecurvaa($vrpecurvaa);
                $paramgeral->setVrpecurvab($vrpecurvab);
                $paramgeral->setVrpecurvac($vrpecurvac);
                $paramgeral->setNrorgultatu($nrorg);
                $paramgeral->setCdoperultatu($operador);
                $paramgeral->setDtultatu($dataAtual);

                $paramgeral->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public function setaNullCamposNutriente() {

        $this->setCdcarbohidra(null);
        $this->setCdproteina(null);
        $this->setCdalcool(null);
        $this->setCdprotvegeta(null);
        $this->setCdlipidios(null);
        $this->setCdprotanimal(null);
        $this->setCdcalorias(null);
        $this->setCdacidgraxos(null);
        $this->setCdglicidios(null);

        $this->persist();

    }

    public function setaNullCamposIntegracao()
    {
        $this->setIdintegra('N');
        $this->setNrorgintegra(null);
        $this->setDsendeintegra(null);

        $this->persist();

    }
}